var constants = angular.module("starter.constants", []);

// 服务器
// var server_domain_name = "daxing2.viewcent.net";
var server_domain_name = "123.124.220.182"; //"daxing2.viewcent.net";
var baseServerUrl = "http://" + server_domain_name + ":8081";
var bookroomBaseUrl = "http://bookroom_api.leituzhiyue.com:8081";

// 定义常量
constants.constant("apiConstants", {
  // 图书
  bookInteraction: {
    // 书籍评论
    comment: {
      // 查询豆瓣评论
      getCommentsFromDoban:
        baseServerUrl + "/book_interaction/library_service/book_info/comment",
    },
    // 图书推荐修改查询
    recommenation: {
      // 分页获取新书推荐列表
      newPageableRecommendedBooks:
        baseServerUrl +
        "/book_interaction/library_service/book_recommenation/new_pageable_recommend_books",
      // 分页获取好书推荐列表
      mostPageableRecommendedBooks:
        baseServerUrl +
        "/book_interaction/library_service/book_recommenation/most_pageable_recommend_books",
      // 获取本地缓存借阅排行榜列表
      localTopLoanedBooks:
        baseServerUrl +
        "/book_interaction/library_service/summary/local/top_loan_books",
    },

    // 图书搜索查询
    search: {
      // 根据关键词查询；根据查询结果集拉取更多；根据图书分类号查询
      search:
        baseServerUrl + "/book_interaction/library_service/book_search/search",
      // 根据分类码查询图书
      searchBooksBycategory:
        baseServerUrl +
        "/book_interaction/library_service/book_search/category_book",
      // 根据书籍id查询馆藏信息
      search_id:
        baseServerUrl +
        "/book_interaction/library_service/book_search/search/id",
    },

    // 图书分类查询修改
    category: {
      // 查询当前启用的图书分类
      enabledCategory:
        baseServerUrl +
        "/book_interaction/library_service/book_category/enabled_category",
    },
    //借书订单
    order: {
      //创建订单
      createOrder:
        baseServerUrl +
        "/book_interaction/library_service/book_order/order_creation",
      //支付
      payOrder:
        baseServerUrl +
        "/book_interaction/library_service/book_order/orderpay_alipay/",
      // 获取支付宝APP的支付参数
      getAliPayInfo:
        baseServerUrl +
        "/book_interaction/library_service/book_order/orderpay_alipay_app",
      // 获取微信APP的支付参数
      getWxPayInfo:
        baseServerUrl +
        "/book_interaction/library_service/book_order/orderpay_wxpay_app",
      //收货
      receiveOrder:
        baseServerUrl +
        "/book_interaction/library_service/book_order/order_receiver/",
      //取消订单
      closeOrder:
        baseServerUrl +
        "/book_interaction/library_service/book_order/order_close/",
      //根据用户查询所有的订单
      findOrdersByStatusAndBorrower:
        baseServerUrl +
        "/book_interaction/library_service/book_order/orders_status_borrower_page",
      //根据运单编号查询订单
      obtainTraceByExpressId:
        baseServerUrl + "/book_interaction/library_service/book_order/deliver/",
      // 查询一个借书订单的详情
      findOrderDetail:
        baseServerUrl +
        "/book_interaction/library_service/book_order/order_detail",
      //查看一个还书订单的详情
      findOrderReturnDetail:
        baseServerUrl +
        "/book_interaction/library_service/book_order/return_order_detail",
      //查看用户所有的订单
      checkAllOrder:
        baseServerUrl +
        "/book_interaction/library_service/book_order/order_statistics",
    },

    // 读者借阅接口
    // 借书
    borrowBook:
      baseServerUrl + "/book_interaction/library_service/book_core/borrow",
    //当前预约
    reserveBook:
      baseServerUrl +
      "/book_interaction/library_service/book_reserve/add_book_to_reserve",
    //历史预约
    historyReserve:
      baseServerUrl +
      "/book_interaction/library_service/book_reserve/book_reserve_item_history_page",
    //获取当前预约图书
    getReserveBook:
      baseServerUrl +
      "/book_interaction/library_service/book_reserve/book_reserve_item_page",
    //借阅预约图书
    loanReserveBooks:
      baseServerUrl +
      "/book_interaction/library_service/book_reserve/loan_reserve_books",
    //刪除预约图书
    deleteReserve:
      baseServerUrl +
      "/book_interaction/library_service/book_reserve/remove_reserve_books",
    //加入选书篮
    addBookCart:
      baseServerUrl +
      "/book_interaction/library_service/book_cart/add_book_to_cart",
    //查询一个读者选书篮中所有的书
    findCartBooks:
      baseServerUrl +
      "/book_interaction/library_service/book_cart/book_cart_item",
    //删除选书篮中的多本书
    deleteCartBooks:
      baseServerUrl +
      "/book_interaction/library_service/book_cart/remove_books_from_cart",
    // 续借
    renewBook:
      baseServerUrl + "/book_interaction/library_service/book_core/renew",
    // 还书
    returnBook:
      baseServerUrl + "/book_interaction/library_service/book_core/return",
    // 查看图书是否可还状态
    returnOrderAllowed:
      baseServerUrl +
      "/book_interaction/library_service/book_order/return_book_allowed",

    // 还书订单物流
    createReturnBookOrder:
      baseServerUrl +
      "/book_interaction/library_service/book_order/return_order_creation",
    // 根据用户id和订单状态分页查询订单信息(Get)
    queryReturnBookOrdersByBorrowIdAndStatus:
      baseServerUrl +
      "/book_interaction/library_service/book_order/return_orders_borrower_page",
    // 根据barcode查询订单信息(Get)
    queryNewestReturnBookOrderByBarcode:
      baseServerUrl + "/bookInteraction/newest_return_order_borrower_barcode",
    //查看一个人的所有还书订单
    checkReturnOrders:
      baseServerUrl +
      "/book_interaction/library_service/book_order/return_order_statistics",
    // 查询读者当前外借，预约记录
    borrowInfo:
      baseServerUrl + "/book_interaction/library_service/book_core/borrow_info",
    // 查询读者借阅历史
    loanHistory:
      baseServerUrl +
      "/book_interaction/library_service/book_core/loan_history",
    // 读者 reader 读者信息修改接口
    reader: {
      // POST 修改登录密码
      change_password:
        baseServerUrl +
        "/book_interaction/library_service/book_patron/change_password",
    },
    // 用户
    user: {
      // 登录
      login: baseServerUrl + "/book_interaction/user/token/auth",
      //refreshToken
      refresh: baseServerUrl + "/book_interaction/user/token/refresh",
      // 登出
      logout: baseServerUrl + "/book_interaction/user/logout",
      //
      // GET 获取用户信息
      getUserInfo: baseServerUrl + "/user/user_info",
      //用户可借本数
      borrowCount: baseServerUrl + "/user/allow_borrow_count",
      //上传设备信息
      deviceInfo: baseServerUrl + "/user/add_device",
    },
    //注册电子卡
    register: {
      //发送验证码
      getVcodeSending:
        baseServerUrl +
        "/book_interaction/reader_member/register_vcode_sending",
      //check验证码
      checkVcodeSending:
        baseServerUrl +
        "/book_interaction/reader_member/register_vcode_checking",
      //获取电子卡的基本信息
      getCardInfo:
        baseServerUrl +
        "/book_interaction/reader_member/reader_card/registrable_reader_card",
      //注册电子证
      registerCard:
        baseServerUrl + "/book_interaction/reader_member/borrower_register",
      //押金支付宝支付
      cashAlipay:
        baseServerUrl +
        "/book_interaction/reader_member/reader_register/deposit_recharge_alipay",
      //押金微信支付
      cashWxpay:
        baseServerUrl +
        "/book_interaction/reader_member/reader_register/deposit_recharge_wxpay",
      //aleph更新押金
      updateCashInAleph:
        baseServerUrl +
        "/book_interaction/reader_member/reader_register/update_new_borrower_cash",
    },
    electronicRead:
      baseServerUrl +
      "/book_interaction/library_service/electronic_resources/get_thirdresource_url",
    //在线书城
    onlineBookstore:
      baseServerUrl +
      "/book_interaction/library_service/electronic_resources/online_bookstore_url",
  },
  bookRoom: {
    //电子期刊
    electronicJournal:
      bookroomBaseUrl + "/bookroom_api/third_resource/get_qikan_url",
    //电子音频
    longyuanAudio:
      bookroomBaseUrl + "/bookroom_api/third_resource/get_longyuan_audio_url",
    //扫码开门
    scanBarcode: {
      //扫码开门命令
      scanBarcodeOpen:
        bookroomBaseUrl + "/bookroom_api/bookroom_qrcode/qrcode_scaning", //baseServerUrl + '/reader_member/qrcode_scaning',
    },
    //海恒设备登录
    haihengDeviceScanQRcode: {
      scanQRcodeByApp:
        bookroomBaseUrl + "/bookroom_api/haiheng_device/scan_qrcode_by_app",
    },
    //获取人脸照片
    faceRecognition: {
      queryBindFace:
        bookroomBaseUrl + "/bookroom_api/reader_face/user_face_image_url",
      unboundFace:
        bookroomBaseUrl + "/bookroom_api/reader_face/user_face_image",
      judgeBindStatus:
        bookroomBaseUrl + "/bookroom_api/reader_face/exist_face_image",
    },
  },

  libraryService: {
    //查看还书的默认地址和电话
    checkReturnDefault:
      baseServerUrl + "/library_service/library_branch/return_branch/DX001",
    //电子资源超星登录
    // 活动报名
    activity: {
      // 所有活动（get）
      activities: baseServerUrl + "/library_service/activity/activities",
      // 通过审核的所有活动（get）
      approved_status_activities:
        baseServerUrl +
        "/library_service/activity/approved_status_page_activities",
      // 用户创建的活动（get）
      owner_activitie:
        baseServerUrl + "/library_service/activity/owner_activities_page",
      // 用户参与的活动（get）
      enroll_activities:
        baseServerUrl + "/library_service/activity/enroll_activities_page",
      // 创建活动（post）/
      activity: baseServerUrl + "/library_service/activity/create_activity",
      // 更新活动（Patch）/删除活动（delete）
      delActivity: baseServerUrl + "/library_service/activity/activity",
      // 报名参加活动（post）/ 取消报名（delete）
      enroll_activity:
        baseServerUrl + "/library_service/activity/enroll_activity",
      // 根据用户id和活动id查询报名情况（get）
      queryEnrollStatusByUserId:
        baseServerUrl + "/library_service/activity/user_enroll_activitie",
    },
    //获取分馆信息
    getLibraryBranch:
      baseServerUrl + "/library_service/library_branch/branches/DX001",
    // 应用升级接口
    app: {
      // GET 获取最新的版本信息
      retrieveNewestUpgradeVersion:
        baseServerUrl + "/library_service/app_version/newest_upgrade_version",
    },
    // sms 短信息
    sms: {
      // POST 发送修改密码的验证码
      sendSmsVerificationCodeForChangePassword:
        baseServerUrl + "/library_service/sms_message/change_password_vcode",
      // GET 查看验证码是否正确
      verifySmsVerificationCode:
        baseServerUrl + "/library_service/sms_message/verify_vcode",
    },
    // 你选书我买单-线上模式
    book_choosing: {
      // 获取所有推荐记录(GET)
      all: baseServerUrl + "/library_service/book/book_choosing_all",
      // 查询某个用户的推荐记录(GET)
      forUser: baseServerUrl + "/library_service/book/book_choosing",
      // 新增记录(POST);
      new: baseServerUrl + "/library_service/book/book_choosing",
      // 根据记录id删除推荐记录(DELETE)
      delete: baseServerUrl + "/library_service/book/book_choosing",
      // 更新一条记录(PUT)
      update: baseServerUrl + "/library_service/book/book_choosing",
      // GET 查询某本书被推荐的次数
      queryBookChoosingCount:
        baseServerUrl + "/library_service/book/book_choosing_count",
    },
    // 消息
    message: {
      // GET 根据用户id获取用户消息
      getUserMessage: baseServerUrl + "/library_service/message/user_message",
      // GET 根据用户id获取分页的用户消息
      getUserPageMessage:
        baseServerUrl + "/library_service/message/user_page_message_category",
      // POST 创建用户消息
      createUserMessage:
        baseServerUrl + "/library_service/message/user_message",
      // Patch 更新用户消息
      updateUserMessage:
        baseServerUrl + "/library_service/message/user_message",
    },
    // 首页数据
    homePage: {
      // 首页滚动图片
      slideImages:
        baseServerUrl +
        "/library_service/news/material_image_page/app_rotation?page=0&size=10&sortedColumn=createTime",
    },
    // 你选书我买单-线下模式
    bookstore: {
      // 获取所有合作书店信息(GET)
      allStores: baseServerUrl + "/library_service/book_store/bookstore_all",
      // 获取一个合作书店信息(GET)  新增一个合作书店(POST)  修改合作书店信息(PUT)   删除一个合作书店(DELETE)
      store: baseServerUrl + "/library_service/book_store/bookstore",
      // 查询合作书店里的书籍(GET)  向合作书店新增一本书籍(POST)   修改合作书店的书籍信息(PUT)    删除合作书店的书籍信息(DELETE)
      book: baseServerUrl + "/library_service/book_store/bookstore_book",
    },
    // 我的书房
    library_room: {
      // GET 查询用户书房信息
      queryLibraryRoomInfo:
        baseServerUrl + "/library_service/library_room/library_room_info",
      // POST 新增一个用户书房信息
      addLibraryRoomInfo:
        baseServerUrl + "/library_service/library_room/library_room_info",
      // PUT 修改某个用户书房信息
      updateLibraryRoomInfo:
        baseServerUrl + "/library_service/library_room/library_room_info",
      // DELETE 删除某用户书房信息
      deleteLibraryRoomInfo:
        baseServerUrl + "/library_service/library_room/library_room_info",

      // 查询用户书房所有书籍(GET)
      userBooks:
        baseServerUrl + "/library_service/library_room/library_room_book",
      // 根据ISBN查询豆瓣书籍信息(GET)
      doubanBookInfo:
        baseServerUrl + "/library_service/library_room/library_room_scan",
      // 新增一本书籍到书房(POST)
      addBookToLibraryRoom:
        baseServerUrl + "/library_service/library_room/library_room_book",
      // 修改书房中书籍信息
      updateBookInLibraryRoom:
        baseServerUrl + "/library_service/library_room/library_room_book",
      // 从书房删除一本书籍
      deleteBookFromLibraryRoom:
        baseServerUrl + "/library_service/library_room/library_room_book",
    },
    // 发现
    discovery: {
      // GET 查找某用户周围的人
      nearby_persons:
        baseServerUrl + "/library_service/discovery/nearby_people",
    },
    // 附近的人
    nearby_people: {
      // POST 上传地理位置
      uploadPersonLocation: baseServerUrl + "/library_service/nearby/people",
      // PATCH 更新地理位置
      updatePersonLocation: baseServerUrl + "/library_service/nearby/people",
      // GET 获取用户指定半径以内的n条记录
      getNearbyPeople: baseServerUrl + "/library_service/nearby/people",
      // GET 查询周围用户书房信息
      getNearbyPeopleLibrooms:
        baseServerUrl + "/library_service/nearby/people_libroom",
      // GET 查询其他用户书房的最新更新的图书
      getRecentBooks: baseServerUrl + "/library_service/nearby/recent_book",
    },
    // 粉丝关注
    fans: {
      // 查询用户粉丝列表 (GET)
      query: baseServerUrl + "/library_service/fans_follow/fans",
      // 删除一位粉丝 (DELETE)
      remove: baseServerUrl + "/library_service/fans_follow/fans",
    },
    // 关注
    follow: {
      // 查询用户关注列表 (GET)
      query: baseServerUrl + "//library_service/fans_follow/follow",
      // 查询是否关注了某用户 (GET)
      check: baseServerUrl + "/library_service/fans_follow/is_fans",
      // 取消一位关注用户 (POST)
      add: baseServerUrl + "/library_service/fans_follow/follow",
      // 取消一位关注用户 (DELETE)
      remove: baseServerUrl + "/library_service/fans_follow/follow",
    },
    // 图书收藏
    favorite: {
      // GET 查询某用户所有收藏
      queryAllFavorites:
        baseServerUrl + "/library_service/favorite_book/favorite",
      // POST 新增一本收藏
      addFavorite: baseServerUrl + "/library_service/favorite_book/favorite",
      // DELETE 根据id删除收藏
      removeFavoriteById:
        baseServerUrl + "/library_service/favorite_book/favorite",
    },
    // 杂项查询
    misc_query: {
      // GET 查询某本书是否被用户推荐,是否被用户收藏
      queryBookConcern:
        baseServerUrl + "/library_service/misc_query/book_concern",
    },
    // 用户名下的孩子
    children: {
      // GET  查询某个用户所有儿童信息
      queryChildrenInfoAll:
        baseServerUrl + "/library_service/user_child/child_info_all",
      // POST 添加一个儿童信息
      addChildInfo: baseServerUrl + "/library_service/user_child/child_info",
      // PUT  修改一个儿童信息
      updateChildInfo: baseServerUrl + "/library_service/user_child/child_info",
      // DELETE 根据id删除用户所有儿童信息
      deleteChildInfo: baseServerUrl + "/library_service/user_child/child_info",
    },
  },

  //用户地址
  address: {
    //新增一个地址
    addAddress: baseServerUrl + "/user/add_address",
    //获取一个人的所有地址
    addressAll: baseServerUrl + "/user/addresses",
    //更新一个地址
    updateAddress: baseServerUrl + "/user/update_address",
    //删除一个地址
    deleteAddress: baseServerUrl + "/user/remove_address",
    //设置一个默认地址
    defaultAddress: baseServerUrl + "/user/default_address/",
    //查询一个人的默认地址
    findDefaultAddress: baseServerUrl + "/user/default_address",
  },
});

// 定义广播常量
constants.constant("broadcastConstants", {
  names: {
    onBookHomeBookChanged: "onBookHomeBookChanged",
    onReservedBookChanged: "onReservedBookChanged",
    onReturnBookChanged: "onReturnBookChanged",
    onPayConfirmBookChanged: "onPayConfirmBookChanged",
    onDeleteBookChoosingChanged: "onDeleteBookChoosingChanged",
    onActivityChanged: "onActivityChanged",
    onPatchActivity: "onPatchActivity",
    onCreateReturnBookOrder: "onCreateReturnBookOrder",
    addressSelected: "addressSelected",
    userInfoChange: "userInfoChange",
    addressDelete: "addressDelete",
  },
});

// 定义日志常量
constants.constant("logConstants", {
  api: {
    upload: baseServerUrl + "/app_set/app_log_data",
  },
});
