angular.module('starter.controllers')

    .controller('BookHomeBookDetailCtrl', function ($controller, $scope, $state, $stateParams, $ionicPopup, $ionicLoading, $ionicModal, $ionicHistory, apiService, bookService, ngCordovaService, uiService, $ionicTabsDelegate, broadcastService, broadcastConstants) {


        // -------------------------------------------------------------------------------------------------------------------
        $scope.book = $stateParams.book;


        // -------------------------------------------------------------------------------------------------------------------
        // 修改书房中书籍信息
        $scope.updateBookInLibraryRoom = function (tmpLibraryRoom) {
            uiService.ionicLoadingShow({ templateTitle: '正在更新图书...' });
            apiService.updateBookInLibraryRoom(tmpLibraryRoom, updateBookInLibraryRoomCallback);
        };
        var updateBookInLibraryRoomCallback = {
            onSuccess: function (data, status, config, headers) {
                $scope.book.libraryRoom = $scope.tmpLibraryRoom;
                $ionicPopup.alert(
                    {
                        title: '更新成功',
                        okText: '确定'
                    }
                ).then(function () {
                    $scope.modal.hide();
                });
                // broadcast
                broadcastService.send(
                    broadcastConstants.names.onBookHomeBookChanged,
                    {
                        operation: 'update',
                        result: 'success',
                        book: $scope.book,
                    }
                );
            },
            onError: function (data, status, config, headers) {
                $ionicPopup.alert(
                    {
                        title: '更新失败',
                        okText: '确定'
                    }
                );
                // broadcast
                broadcastService.send(
                    broadcastConstants.names.onBookHomeBookChanged,
                    {
                        operation: 'update',
                        result: 'failed',
                        book: $scope.book,
                    }
                );
            },
            onFinally: function () {
                $ionicLoading.hide();
            }
        };

        // -------------------------------------------------------------------------------------------------------------------
        // 从书房删除一本书籍
        $scope.deleteBookFromLibraryRoom = function (tmpLibraryRoom) {
            $ionicPopup.confirm(
                {
                    title: '删除图书',
                    template: '真的要删除吗？',
                    cancelText: '取消',
                    okText: '确定'
                }
            ).then(function (res) {
                if (res) {
                    uiService.ionicLoadingShow({ templateTitle: '正在删除图书...' });
                    deleteBookFromLibraryRoomCallback.id = tmpLibraryRoom.id;
                    apiService.deleteBookFromLibraryRoom(tmpLibraryRoom.id, deleteBookFromLibraryRoomCallback);
                }
            });
        };
        var deleteBookFromLibraryRoomCallback = {
            id: null,
            onSuccess: function (data, status, config, headers) {
                $ionicPopup.alert(
                    {
                        title: '删除成功',
                        okText: '确定'
                    }
                ).then(function () {
                    $scope.modal.hide();
                    // $state.go('tab.home');
                    $ionicHistory.goBack();
                });
                // broadcast
                broadcastService.send(
                    broadcastConstants.names.onBookHomeBookChanged,
                    {
                        operation: 'delete',
                        result: 'success',
                        book: $scope.book,
                    }
                );
            },
            onError: function (data, status, config, headers) {
                $ionicPopup.alert(
                    {
                        title: '删除失败',
                        okText: '确定'
                    }
                );
            },
            onFinally: function () {
                $ionicLoading.hide();
            }
        };


        // -------------------------------------------------------------------------------------------------------------------
        $ionicModal.fromTemplateUrl('modules/bookhome/hb_book_edit.html', {
            scope: $scope
        }).then(function (modal) {
            $scope.modal = modal;
        });
        $scope.edit = function () {
            // $scope.tmpLibraryRoom = {};
            // $scope.tmpLibraryRoom.isbn = $scope.book.libraryRoom.isbn;
            // $scope.tmpLibraryRoom.count = $scope.book.libraryRoom.count;
            // $scope.tmpLibraryRoom.loanable = $scope.book.libraryRoom.loanable;
            $scope.tmpLibraryRoom = angular.copy($scope.book.libraryRoom);
            $scope.modal.show();
        };
        $ionicTabsDelegate.showBar(false);


        // ----------------------------------------------------------------------------------------------------------------
        // 获取base controller，并将其扩展至当前controller中。
        var baseBookDetailCtrl = $controller('baseBookDetailCtrl', { $scope: $scope });
        angular.extend(this, baseBookDetailCtrl);
        if ($scope.book && $scope.book.basebook) {
            $scope.init($scope.book.basebook.isbn); // init函数是base controller中的
        }


    });
