angular.module('starter.controllers')

    .controller('BookHomeBooksCtrl', function ($scope, $stateParams, $state, $ionicPopup, $ionicLoading, apiService, uiService, $ionicTabsDelegate, broadcastService, broadcastConstants) {

        // -------------------------------------------------------------------------------------------------------------------
        $scope.user_id = $stateParams.user_id;
        $scope.loanable = $stateParams.loanable;
        $scope.books = [];
        $scope.username = $scope.user_id == $scope.user.account ? '我' : $stateParams.username;


        // -------------------------------------------------------------------------------------------------------------------


        // -------------------------------------------------------------------------------------------------------------------
        // 当前用户书房的所有图书
        $scope.retrieveAllBookFromUserLibraryRoom = function (slient) {
            if (slient == true) {
            } else {
                uiService.ionicLoadingShow({ templateTitle: '正在获取书房图书...' });
            }
            if ($scope.loanable) {
                apiService.retrieveLoanableBooksFromUserLibraryRoom($scope.user.account, retrieveBooksFromUserLibraryRoomCallback);
            } else {
                apiService.retrieveAllBooksFromUserLibraryRoom($scope.user_id, retrieveBooksFromUserLibraryRoomCallback);
            }
        };
        var retrieveBooksFromUserLibraryRoomCallback = {
            onSuccess: function (data, status, config, headers) {
                $scope.books = data;
            },
            onError: function (data, status, config, headers) {
                // do nothing
            },
            onFinally: function () {
                $ionicLoading.hide();
            }
        };





        // -------------------------------------------------------------------------------------------------------------------
        $scope.goDetail = function (book) {
            $state.go('tab.bhbookdetail',
                {
                    book: book
                }
            );
        }

        // -------------------------------------------------------------------------------------------------------------------
        var onBookHomeBookChangedListener = function (data) {
            console.log('BookHomeBooksCtrl', angular.toJson(data, true));
            $scope.retrieveAllBookFromUserLibraryRoom(true);
        };
        broadcastService.register(broadcastConstants.names.onBookHomeBookChanged, onBookHomeBookChangedListener);
        $scope.$on('$destroy', function () {
            broadcastService.unregister(broadcastConstants.names.onBookHomeBookChanged, onBookHomeBookChangedListener);
        });



        // -------------------------------------------------------------------------------------------------------------------
        $scope.retrieveAllBookFromUserLibraryRoom();
        $ionicTabsDelegate.showBar(false);
    });
