angular.module('starter.controllers')

    .controller('BookhomeSettingCtrl', function ($scope, $stateParams, $ionicHistory, $ionicLoading, $ionicTabsDelegate, apiService, uiService, ngCordovaService, $ionicTabsDelegate) {
        //
        $ionicTabsDelegate.showBar(true);


        //
        $scope.libraryRoomInfo = $stateParams.libraryRoomInfo;
        $scope.editableLibraryRoomInfo = null;
        $scope.data = {
            status: null, // 'show', 'edit', 'create'
        };
        if ($scope.libraryRoomInfo) {
            $scope.data.status = 'show';
        } else {
            $scope.data.status = 'create';
            $scope.editableLibraryRoomInfo = {
                userId: $scope.user.account,
                userNickName: '',
                libraryName: '',
                signature: '',
                visible: 1
            };
        }


        // ---------------------------------------------------------------------------------------------------------
        $scope.edit = function () {
            if (!$scope.editableLibraryRoomInfo) {
                $scope.editableLibraryRoomInfo = angular.copy($scope.libraryRoomInfo);
            }
            $scope.data.status = 'edit';
        };
        $scope.cancelEdit = function () {
            $scope.data.status = 'show';
        };



        // ---------------------------------------------------------------------------------------------------------
        $scope.updateLibraryRoomInfo = function () {
            uiService.ionicLoadingShow({ templateTitle: '正在更新书房信息...' });
            apiService.updateLibraryRoomInfo($scope.editableLibraryRoomInfo, updateLibraryRoomInfoCallback);
        };
        var updateLibraryRoomInfoCallback = {
            onSuccess: function (data, status, config, headers) {
                console.log('更新书房信息成功');
                ngCordovaService.showToast('更新书房信息成功');
                $scope.libraryRoomInfo = data;
                $scope.data.status = 'show';
            },
            onError: function (data, status, config, headers) {
                console.log('更新书房信息失败');
                ngCordovaService.showToast('更新书房信息失败');
            },
            onFinally: function () {
                $ionicLoading.hide();
            }
        };



        // ---------------------------------------------------------------------------------------------------------
        $scope.addLibraryRoomInfo = function () {
            uiService.ionicLoadingShow({ templateTitle: '正在创建书房...' });
            apiService.addLibraryRoomInfo($scope.editableLibraryRoomInfo, addLibraryRoomInfoCallback);
        };
        var addLibraryRoomInfoCallback = {
            onSuccess: function (data, status, config, headers) {
                console.log('创建书房成功');
                ngCordovaService.showToast('创建书房成功');
                $scope.libraryRoomInfo = data;
                $scope.data.status = 'show';
                //
                $scope.editableLibraryRoomInfo = null;
            },
            onError: function (data, status, config, headers) {
                console.log('创建书房失败');
                ngCordovaService.showToast('更新书房失败');
            },
            onFinally: function () {
                $ionicLoading.hide();
            }
        };

$ionicTabsDelegate.showBar(false);



    });
