angular.module('starter.controllers')

    .controller('loanedBookDetailCtrl', function ($controller, $scope, $stateParams, $state, $ionicHistory, $ionicSlideBoxDelegate, $ionicLoading, $ionicPopup, apiService, ngCordovaService, uiService, bookService, $ionicTabsDelegate, broadcastService, broadcastConstants) {

        //
        $scope.loanedBook = $stateParams.loanedBook;    // 当前图书
        $scope.allowLoanedBooks = [];                   // 可借阅图书
        $scope.totalBooks = [];                         // 所有图书 
        $scope.returnOrderAllowed = undefined;          // 还书订单是否可以创建，即是否可以执行还书操作。

        // ----------------------------------------------------------------------------------------------------------------
        // 获取图书详情的回调方法
        var callback = {
            onSuccess: onSuccess,
            onError: onError,
            onBefore: onBefore,
            onAfter: onAfter
        };
        function onSuccess(data) {
            if (data) {
                $scope.allowLoanedBooks = data.allowLoanedBooks;
                $scope.totalBooks = data.totalBooks;
            }
        }
        function onError() {
            // TODO
        }
        function onBefore() {
            uiService.ionicLoadingShow({ templateTitle: '加载中...' });
        }
        function onAfter() {
            $ionicLoading.hide();
        }



        // --------------------------------------------------------------------------------------------
        // 续借
        $scope.renewBook = function () {
            uiService.ionicLoadingShow({ templateTitle: '续借中...' });//wsc-change
            apiService.renewBook($scope.loanedBook.barcode, $scope.user.borrowID, renewBookCallback);
        }
        var renewBookCallback = {
            onSuccess: function (data, status, config, headers) {
                var msg = '';
                if (data) {
                    msg = data.msg;
                    if (!msg) {
                        var status = data.status; // 目前已知的状态可能有：'success','fail'
                        if (status == 'success') {
                            msg = '续借成功';
                        } else if (status == 'fail') {
                            msg = '续借失败';
                        }
                    }
                } else {
                    msg = '未知结果！';
                }
                $ionicPopup.alert({
                    title: msg,
                    okText: '确定'
                }).then(function () {
                    // TODO 临时什么也不做，发现history方式有问题
                    // // 返回上一页面
                    // $ionicHistory.goBack(-1);
                });

            },
            onError: function (data, status, config, headers) {
                var msg = '续借失败';
                $ionicPopup.alert({
                    title: msg,
                    okText: '确定'
                }).then(function () {
                });
            },
            /******************wsc-change********************/
            onFinally: function () {
                $ionicLoading.hide();
            }
        };


        // --------------------------------------------------------------------------------------------
        // 还书
        $scope.returnBook = function () {
            $state.go('returnbook', { loanedBook: $scope.loanedBook });
        };


        // 查看图书是否可还状态
        $scope.checkReturnOrderAllowed = function () {
            $scope.returnOrderAllowed = undefined;
            apiService.checkReturnOrderAllowed(
                $scope.user.borrowID,
                $scope.loanedBook.barcode,
                {
                    onSuccess: function (data, status, config, headers) {
                        if (_.isEmpty(data)) {
                            $scope.returnOrderAllowed = {
                                status: 'known', // 正常情况下，只有“OK”和“ERROR”，这里做一个异常处理。
                                data: '获取可还状态失败',
                            };
                        }
                        $scope.returnOrderAllowed = data;
                    },
                    onError: function (data, status, config, headers) {
                        console.log('获取是否可还状态失败');
                        $scope.returnOrderAllowed = {
                            status: 'known', // 正常情况下，只有“OK”和“ERROR”，这里做一个异常处理。
                            data: '获取可还状态失败',
                        };
                    },
                    onFinally: function () {
                        //
                    }
                }
            );
        };

        $scope.showReturnOrderNotAllownedReason = function () {
            var msg = $scope.returnOrderAllowed.data;
            if (_.isEmpty(msg)) {
                msg = '当前状态不允许还书';
            }
            $ionicPopup.alert({
                title: msg,
                okText: '确定'
            });
        }


        // ---------------------------------------------------------------------------------------------------------------- 
        apiService.retrieveBookDetail($scope.loanedBook.groupBookID, callback);
        $scope.checkReturnOrderAllowed();
        $ionicTabsDelegate.showBar(false);

        // ----------------------------------------------------------------------------------------------------------------
        // 获取base controller，并将其扩展至当前controller中。
        var baseBookDetailCtrl = $controller('baseBookDetailCtrl', { $scope: $scope });
        angular.extend(this, baseBookDetailCtrl);
        if ($scope.loanedBook) {
            $scope.init($scope.loanedBook.isbn); // init函数是base controller中的
        }



        //
        /********************还书订单监听器*************************/
        var onCreateReturnBookOrderListener = function () {
            $scope.queryNewestReturnBookOrderByBarcode();
        };
        //监听和反监听
        broadcastService.register(broadcastConstants.names.onCreateReturnBookOrder, onCreateReturnBookOrderListener);
        $scope.$on('$destroy', function () {
            broadcastService.unregister(broadcastConstants.names.onCreateReturnBookOrder, onCreateReturnBookOrderListener);
        });

    });

