angular.module('starter.controllers')

    .controller('DiscoveryBookHomeBooksCtrl', function ($scope, $stateParams, $state, $ionicPopup, $ionicLoading, apiService, uiService, $ionicTabsDelegate) {

        // -------------------------------------------------------------------------------------------------------------------
        $scope.person = $stateParams.person;
        $scope.loanable = $stateParams.loanable;
        $scope.books = [];


        // -------------------------------------------------------------------------------------------------------------------


        // -------------------------------------------------------------------------------------------------------------------
        // 当前用户书房的所有图书
        $scope.retrieveAllBookFromUserLibraryRoom = function () {
            uiService.ionicLoadingShow({ templateTitle: '正在获取书房图书...' });
            if ($scope.loanable) {
                apiService.retrieveLoanableBooksFromUserLibraryRoom($scope.person.userId, retrieveBooksFromUserLibraryRoomCallback);
            } else {
                apiService.retrieveAllBooksFromUserLibraryRoom($scope.person.userId, retrieveBooksFromUserLibraryRoomCallback);
            }
        };
        var retrieveBooksFromUserLibraryRoomCallback = {
            onSuccess: function (data, status, config, headers) {
                $scope.books = data;
            },
            onError: function (data, status, config, headers) {
                // do nothing
            },
            onFinally: function () {
                $ionicLoading.hide();
            }
        };





        // -------------------------------------------------------------------------------------------------------------------
        $scope.goBookDetailDrift = function (book) {
            if (book) {
                var currentState = $ionicHistory.currentStateName();
                var targetStateName = undefined;
                switch (currentState) {
                    case 'tab.dcHomeBooks':
                        targetStateName = 'tab.dcbookdetaildrift';
                        break;
                    case 'tab.minedcHomeBooks':
                        targetStateName = 'tab.minedcbookdetaildrift';
                        break;
                }
                if (targetStateName) {
                    $state.go(targetStateName,
                        {
                            book: book
                        }
                    );
                }
            }
        }




        // -------------------------------------------------------------------------------------------------------------------
        $scope.retrieveAllBookFromUserLibraryRoom();
        $ionicTabsDelegate.showBar(false);
    });
