angular.module('starter.controllers')

    // 图书分类
    .controller('CategoryCtrl', function ($scope, $stateParams, $state, $ionicLoading, apiService, uiService, $ionicTabsDelegate, $ionicHistory) {
        // ----------------------------------------------------------------------------------------------------------------
        //
        $scope.loadFailed = false;
        $scope.loadFailedMsg = '加载失败， 点击此处重新加载...';
        $scope.loadError = false;
        $scope.loadErrorMsg = '错误的请求或者存在网络问题 -_-';
        $scope.categories = [];
        $scope.load = function () {
            apiService.retrieveBookCategories(callback);
        };


        // ----------------------------------------------------------------------------------------------------------------
        // 获取图书分类的回调方法
        var callback = {
            onSuccess: onSuccess,
            onFailed: onFailed,
            onError: onError,
            onBefore: onBefore,
            onAfter: onAfter
        };
        function onSuccess(data) {
            $scope.loadFailed = false;
            $scope.loadError = false;
            $scope.categories = data;
        }
        function onFailed() {
            $scope.loadFailed = true;
            $scope.loadError = false;
        }
        function onError() {
            $scope.loadFailed = false;
            $scope.loadError = true;
        }
        function onBefore() {
            uiService.ionicLoadingShow({ templateTitle: '加载中...' });
        }
        function onAfter() {
            $ionicLoading.hide();
        }


        // ----------------------------------------------------------------------------------------------------------------
        $scope.goConditionalSearchBook = function (category) {
            $ionicHistory.clearCache().then(
                function () {
                    $state.go('tab.searchBook', { category: category });
                }
            );
        };


        // ----------------------------------------------------------------------------------------------------------------
        //  主动加载一次
        $scope.load();
        $ionicTabsDelegate.showBar(false);
    });
