angular.module('starter.controllers')

    // 好书列表
    .controller('GoodBookMoreCtrl', function ($rootScope, $scope, $stateParams, $state, apiService, bookService, $ionicTabsDelegate, $ionicHistory,$ionicLoading) {
        
        $scope.account;
        if (!$scope.user) {
            $scope.account = '';
        }else{
            $scope.account = $rootScope.userInfo.account;
        }
        
        // 消息
        $scope.refreshFailed = false;
        $scope.refreshFailedMsg = '刷新失败，下拉重新刷新';
        $scope.refreshSuccessful = false;
        $scope.loadMoreFailed = false;
        $scope.loadMoreFailedMsg = '加载更多失败，上拉重新加载';
        //
        $scope.curPage = -1;
        $scope.pageSize = 10;
        $scope.totalPages = 0;
        $scope.elementsCount = 0;
        $scope.moreDataCanBeLoaded = false;


        // ----------------------------------------------------------------------------------------------------------------
        // 刷新和加载更多
        $scope.refresh = function () {
            // reset
            $scope.curPage = -1;
            $scope.refreshSuccessful = false;
            $scope.moreDataCanBeLoaded = false;
            //
            apiService.retrieveMostRecommendedBooks($scope.account,$scope.curPage + 1, $scope.pageSize, {
                onSuccess: onRefreshSuccess,
                onError: onRefreshError
            });
        };
        $scope.loadMore = function () {
            if (!$scope.refreshSuccessful) {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                return;
            }
            apiService.retrieveMostRecommendedBooks($scope.account,$scope.curPage + 1, $scope.pageSize, {
                onSuccess: onLoadMoreSuccess,
                onError: onLoadMoreError
            });
        };
        // 刷新和加载更多的事件监听器
        function onRefreshSuccess(data) {
            console.log('onRefreshSuccess');
            // 
            var books = data.data;
            bookService.fixBooks(books);
            //
            $scope.books = books;
            $scope.elementsCount = data.elementsCount;
            $scope.totalPages = data.totalPages;
            //
            if ($scope.books.length < $scope.elementsCount) {
                $scope.moreDataCanBeLoaded = true;
            } else {
                $scope.moreDataCanBeLoaded = false;
            }
            $scope.curPage = $scope.curPage + 1;
            $scope.refreshFailed = false;
            $scope.refreshSuccessful = true;
            // 发送广播
            $scope.$broadcast('scroll.refreshComplete');
        };
        function onRefreshError() {
            console.log('onRefreshError');
            $scope.refreshFailed = true;
            // 发送广播
            $scope.$broadcast('scroll.refreshComplete');
        };
        function onLoadMoreSuccess(data) {
            console.log('onLoadMoreSuccess');
            //
            var books = data.data;
            bookService.fixBooks(books);
            //
            if ($scope.books) {
                for (var i = 0; i < books.length; i++) {
                    $scope.books.push(books[i]);
                }
            } else {
                $scope.books = books;
            }
            $scope.elementsCount = data.elementsCount;
            $scope.totalPages = data.totalPages;
            //
            if ($scope.books.length < $scope.elementsCount) {
                $scope.moreDataCanBeLoaded = true;
            } else {
                $scope.moreDataCanBeLoaded = false;
            }
            //
            $scope.curPage = $scope.curPage + 1;
            $scope.loadMoreFailed = false;
            // 发送广播
            $scope.$broadcast('scroll.infiniteScrollComplete');
        };
        function onLoadMoreError() {
            console.log('onLoadMoreError');
            $scope.loadMoreFailed = true;
            // 发送广播
            $scope.$broadcast('scroll.refreshComplete');
        };



        // ----------------------------------------------------------------------------------------------------------------
        $scope.goDetail = function (book) {
            $state.go('tab.book-detail', { book: book });
        }


        // ----------------------------------------------------------------------------------------------------------------
        // 主动刷新一次
        // if ($stateParams.firstPageGoodBooks && $stateParams.firstPageGoodBooks.length > 0) {
        //     $scope.books = $stateParams.firstPageGoodBooks;
        //     $scope.pageSize = $stateParams.firstPageGoodBooks.length;
        //     $scope.refreshSuccessful = true;
        //     $scope.moreDataCanBeLoaded = true;
        // } else {
            $scope.refresh();
        // }
        $ionicTabsDelegate.showBar(false);
    });

