angular.module('starter.controllers')

    .controller('FansCtrl', function ($ionicTabsDelegate, $scope, $state, $stateParams, apiService, uiService, $ionicLoading, $ionicPopup) {


        //
        if (!$scope.user) {
            $state.go('tab.mine');
        }
        $ionicTabsDelegate.showBar(false);
        //
        $scope.fans = $stateParams.fans;
        var tmpFan = null;



        // -----------------------------------------------------------------------------------------
        $scope.queryFans = function () {
            uiService.ionicLoadingShow({ templateTitle: '正在查询...' });
            apiService.queryFans($scope.user.account, queryFansCallback);
        };
        var queryFansCallback = {
            onSuccess: function (data, status, config, headers) {
                $scope.fans = data;
            },
            onError: function (data, status, config, headers) {
                //
            },
            onFinally: function () {
                // 隐藏进度条
                $ionicLoading.hide().then(function () {
                    console.log("The loading indicator is now hidden");
                });
            }
        };


        // -----------------------------------------------------------------------------------------
        $scope.deleteFan = function (fan) {
            $ionicPopup.confirm(
                {
                    title: '删除粉丝',
                    template: '真的要删除该粉丝吗？',
                    cancelText: '取消',
                    okText: '确定'
                }
            ).then(function (res) {
                uiService.ionicLoadingShow({ templateTitle: '正在删除粉丝...' });
                tmpFan = fan;
                apiService.removeFan(fan.id, removeFanCallback);
            });
        };
        var removeFanCallback = {
            onSuccess: function (data, status, config, headers) {
                if (tmpFan) {
                    for (var i = 0; i < $scope.fans.length; i++) {
                        if (tmpFan == $scope.fans[i]) {
                            $scope.fans.splice(i, 1);
                            break;
                        }
                    }
                }
            },
            onError: function (data, status, config, headers) {
                $ionicPopup.alert(
                    {
                        title: '无法删除该粉丝',
                        okText: '确定'
                    }
                );
            },
            onFinally: function () {
                // 隐藏进度条
                $ionicLoading.hide().then(function () {
                    console.log("The loading indicator is now hidden");
                });
            }
        };

        // -----------------------------------------------------------------------------------------
        $scope.goFan = function (fan) {
            $state.go('tab.minedcbhdetail', { person: fan });
        };


        // -----------------------------------------------------------------------------------------
        // init and check
        // 如果之前的页面来不及提供粉丝，这里做一次主动查询。
        if (!$scope.fans) {
            $scope.queryFans();
        }


    });
