angular.module('starter.controllers')

    .controller('MyFavoritesCtrl', function ($ionicTabsDelegate,$scope, $state, $stateParams, apiService, uiService, $ionicLoading, $ionicPopup) {

        $ionicTabsDelegate.showBar(false);
        //
        if (!$scope.user) {
            $state.go('tab.mine');
        }

        // -----------------------------------------------------------------------------------------
        // $scope.favorites = $stateParams.favorites;
        var tmpFavorite = null;



        // -----------------------------------------------------------------------------------------
        $scope.queryAllFavorites = function () {
            uiService.ionicLoadingShow({ templateTitle: '正在查询...' });
            apiService.queryAllFavorites($scope.user.account, queryAllFavoritesCallback);
        };
        var queryAllFavoritesCallback = {
            onSuccess: function (data, status, config, headers) {
                // $scope.favorites = data;
                // 放在null元素导致在UI中无法显示正常元素
                if (data) {
                    console.log(data)
                    $scope.favorites = [];
                    for (var i = 0; i < data.length; i++) {
                        var favorite = data[i];
                        if (favorite) {
                            $scope.favorites.push(favorite);
                        }
                    }
                }
            },
            onError: function (data, status, config, headers) {
                //
            },
            onFinally: function () {
                // 隐藏进度条
                $ionicLoading.hide();
            }
        };


        // -----------------------------------------------------------------------------------------
        $scope.removeFavorite = function (favorite) {
            $ionicPopup.confirm(
                {
                    title: '删除收藏',
                    template: '真的要删除该收藏吗？',
                    cancelText: '取消',
                    okText: '确定'
                }
            ).then(function (res) {
                uiService.ionicLoadingShow({ templateTitle: '正在删除收藏...' });
                tmpFavorite = favorite;
                apiService.removeFavoriteById(favorite.info.id, removeFavoriteByIdCallback);
            });
        };
        var removeFavoriteByIdCallback = {
            onSuccess: function (data, status, config, headers) {
                if (tmpFavorite) {
                    $scope.favorites.splice($scope.favorites.indexOf(tmpFavorite), 1);
                }
            },
            onError: function (data, status, config, headers) {
                $ionicPopup.alert(
                    {
                        title: '无法删除该关注',
                        okText: '确定'
                    }
                );
            },
            onFinally: function () {
                // 隐藏进度条
                $ionicLoading.hide().then(function () {
                    console.log("The loading indicator is now hidden");
                });
            }
        };



        // -----------------------------------------------------------------------------------------
        $scope.goFavorite = function (basebook) {
            $state.go('tab.mine_favorite_detail', { book: basebook });
        };

        // -----------------------------------------------------------------------------------------
        // init and check
        // 如果之前的页面来不及提供粉丝，这里做一次主动查询。
        if (!$scope.follows) {
            $scope.queryAllFavorites();
        }


    });
