angular.module('starter.controllers')

    .controller('FollowCtrl', function ($ionicTabsDelegate, $scope, $state, $stateParams, apiService, uiService, $ionicLoading, $ionicPopup) {


        //
        if (!$scope.user) {
            $state.go('tab.mine');
        }
        $ionicTabsDelegate.showBar(false);
        //
        $scope.follows = $stateParams.follows;
        var tmpFollow = null;


        // -----------------------------------------------------------------------------------------
        $scope.queryFollows = function () {
            uiService.ionicLoadingShow({ templateTitle: '正在查询...' });
            apiService.queryFollows($scope.user.account, queryFollowsCallback);
        };
        var queryFollowsCallback = {
            onSuccess: function (data, status, config, headers) {
                $scope.follows = data;
            },
            onError: function (data, status, config, headers) {
                //
            },
            onFinally: function () {
                // 隐藏进度条
                $ionicLoading.hide().then(function () {
                    console.log("The loading indicator is now hidden");
                });
            }
        };


        // -----------------------------------------------------------------------------------------
        $scope.removeFollow = function (follow) {
            $ionicPopup.confirm(
                {
                    title: '删除关注',
                    template: '真的要删除该关注吗？',
                    cancelText: '取消',
                    okText: '确定'
                }
            ).then(function (res) {
                uiService.ionicLoadingShow({ templateTitle: '正在删除关注...' });
                tmpFollow = follow;
                apiService.removeFollow(follow.id, removeFollowCallback);
            });
        };
        var removeFollowCallback = {
            onSuccess: function (data, status, config, headers) {
                if (tmpFollow) {
                    for (var i = 0; i < $scope.follows.length; i++) {
                        if (tmpFollow == $scope.follows[i]) {
                            $scope.follows.splice(i, 1);
                            break;
                        }
                    }
                }
            },
            onError: function (data, status, config, headers) {
                $ionicPopup.alert(
                    {
                        title: '无法删除该关注',
                        okText: '确定'
                    }
                );
            },
            onFinally: function () {
                // 隐藏进度条
                $ionicLoading.hide().then(function () {
                    console.log("The loading indicator is now hidden");
                });
            }
        };



        // -----------------------------------------------------------------------------------------
        $scope.goFollow = function (follow) {
            $state.go('tab.minedcbhdetail', { person: follow });
        };

        // -----------------------------------------------------------------------------------------
        // init and check
        // 如果之前的页面来不及提供粉丝，这里做一次主动查询。
        if (!$scope.follows) {
            $scope.queryFollows();
        }


    });
