angular
  .module("starter.controllers")

  .controller(
    "IdentityAuthenticationCtrl",
    function (
      $scope,
      $state,
      $ionicLoading,
      uiService,
      ngCordovaService,
      $ionicActionSheet,
      $ionicTabsDelegate,
      $cordovaImagePicker,
      $cordovaCamera,
      $cordovaFileTransfer,
      $interval
    ) {
      $scope.goWriteInfo = function () {
        $state.go("tab.writeInfo", {
          name: $scope.idCardInfo.name,
          gender: $scope.idCardInfo.gender,
          id: $scope.idCardInfo.id,
        });
      };

      $scope.data = {
        status: null,
        newAvatorLocalUrl: null,
        backImgUrl: null,
      };
      $scope.idCardInfo = {
        name: "",
        id: "",
        gender: "",
      };

      //上传提示
      $scope.uploadTip = function () {
        ngCordovaService.showToast("请先上传正确的身份证照片");
      };
      $scope.showImg = false;
      $scope.backImgShow = false;
      $scope.clearBuffer = false;
      //$scope.cardId = null;
      $scope.showMenu = function (id) {
        $ionicActionSheet.show({
          buttons: [{ text: "从相册选择图片" }, { text: "拍照" }],
          buttonClicked: function (index) {
            switch (index) {
              case 0:
                $scope.pickImageFromLocal(id);
                break;
              case 1:
                $scope.capturePictureByCamera(id);
                break;
              default:
                break;
            }
            return true;
          },
        });
      };

      $scope.pickImageFromLocal = function (id) {
        var options = {
          maximumImagesCount: 1,
          // width: 800,
          // height: 800,
          // quality: 80
        };
        $cordovaImagePicker.getPictures(options, id).then(
          function (results) {
            for (var i = 0; i < results.length; i++) {
              console.log("pickImageFromLocal. Image URI: " + results[i]);
            }
            if (results.length == 1) {
              var imgArry = results[0].split(".");
              var arryLast = imgArry.pop();
              if (arryLast == "jpg" || arryLast == "jpeg") {
                if (id == 1) {
                  $scope.data.newAvatorLocalUrl = results[0];
                  $scope.showImg = true;
                  $scope.uploadNewAvator(id, $scope.data.newAvatorLocalUrl);
                } else {
                  $scope.backImgShow = true;
                  $scope.data.backImgUrl = results[0];
                  $scope.uploadNewAvator(id, $scope.data.backImgUrl);
                }
              } else {
                ngCordovaService.showToast(
                  "仅支持jpg或jpeg格式的图片，暂不支持其他格式"
                );
              }
            }
          },
          function (error) {
            // error getting photos
            console.log();
          }
        );
      };

      $scope.capturePictureByCamera = function (id) {
        var options = {
          destinationType: Camera.DestinationType.FILE_URI,
          sourceType: Camera.PictureSourceType.CAMERA,
          encodingType: Camera.EncodingType.JPEG,
          correctOrientation: true, //ios上所拍的图片方向不对
          saveToPhotoAlbum: true,
        };
        $cordovaCamera.getPicture(options, id).then(
          function (imageURI) {
            console.log("capturePictureByCamera. Image URI: " + imageURI);
            var imgArry = imageURI.split(".");
            var arryLast = imgArry.pop();
            if (arryLast == "jpg" || arryLast == "jpeg") {
              if (id == 1) {
                $scope.data.newAvatorLocalUrl = imageURI;
                $scope.showImg = true;
                $scope.uploadNewAvator(id, $scope.data.newAvatorLocalUrl);
              } else {
                $scope.backImgShow = true;
                $scope.data.backImgUrl = imageURI;
                $scope.uploadNewAvator(id, $scope.data.backImgUrl);
              }
            } else {
              ngCordovaService.showToast(
                "仅支持jpg或jpeg格式的图片，暂不支持其他格式"
              );
            }
          },
          function (err) {
            // error
            console.log("capturePictureByCamera. Image URI err : " + err);
          }
        );
        // $cordovaCamera.cleanup(); // only for FILE_URI
      };

      //上传照片
      $scope.uploadNewAvator = function (id, imgUrl) {
        var idCard = id;
        $scope.clearBuffer = false;
        uiService.ionicLoadingShow({ templateTitle: "扫描中..." });
        if (id == 1) {
          var server =
            baseServerUrl +
            "/book_interaction/reader_member/idcard_file_registered";
        } else {
          if ($scope.idCardInfo.id == "") {
            $scope.backImgShow = false;
            $ionicLoading.hide();
            ngCordovaService.showToast("请先上传身份证正面照");
            return;
          } else {
            var server =
              baseServerUrl +
              "/book_interaction/reader_member/idcard_backfile_upload/" +
              $scope.idCardInfo.id;
          }
        }
        var filePath = imgUrl;
        var options = null;
        var uploadFile = $cordovaFileTransfer.upload(server, filePath, options);
        $scope.codeTime = 10;
        var int = $interval(function () {
          $scope.codeTime--;
          if ($scope.codeTime == 0) {
            if ($scope.clearBuffer == false) {
              uploadFile.abort();
            }
            $interval.cancel(int);
          }
        }, 1000);
        uploadFile.then(
          function (result) {
            $scope.clearBuffer = true;
            // Success!
            $ionicLoading.hide();
            var response = angular.fromJson(result.response);
            if (idCard == 1) {
              if (response.status == "ERROR") {
                ngCordovaService.showToast(response.data, 6000);
                $scope.showImg = false;
                $scope.idCardInfo.id = "";
                $scope.idCardInfo.name = "";
                $scope.idCardInfo.gender = "";
              } else {
                $scope.idCardInfo.id = response.data.frontInfo.id;
                $scope.idCardInfo.name = response.data.frontInfo.name;
                $scope.idCardInfo.gender = response.data.frontInfo.gender;
                $scope.showImg = true;
                ngCordovaService.showToast("扫描通过");
              }
            } else {
              if (response.status == "ERROR") {
                ngCordovaService.showToast(response.data);
                $scope.backImgShow = false;
              } else {
                ngCordovaService.showToast("扫描通过");
                $scope.backImgShow = true;
              }
            }
          },
          function (err) {
            // Error
            $ionicLoading.hide();
            ngCordovaService.showToast("上传失败，请重新上传");
            if (idCard == 1) {
              $scope.showImg = false;
            } else {
              $scope.backImgShow = false;
            }
          },
          function (progress) {
            // var p = progress.loaded / progress.total;
            // p = Math.floor(p * 100) + '%';
            // console.log(p);
          }
        );
      };

      $ionicTabsDelegate.showBar(false);
    }
  );
