angular.module('starter.controllers')

    .controller('MineCheckMessagesCtrl', function ($scope, $ionicSlideBoxDelegate, $ionicTabsDelegate, $ionicLoading, apiService, uiService, ngCordovaService,$stateParams) {

        // ---------------------------------------------------------------------------------------------------
        $ionicTabsDelegate.showBar(false);




        // ---------------------------------------------------------------------------------------------------
        $scope.pageCount = 0;
        $scope.pageSize = 10;
        $scope.messages = [];
        $scope.sortedColumn = 'createTime';
        //
        $scope.hasGotAllMessages = false;
        $scope.loading = false;
        //
        $scope.avatar_default = baseServerUrl + '/resources/head_images/mpic/default.jpg';


        //
        $scope.reset = function () {
            $scope.pageCount = 0;
            $scope.messages = [];
            $scope.hasGotAllMessages = false;
            $scope.loading = false;
        };


        // ---------------------------------------------------------------------------------------------------
        // 根据用户id获取用户消息
        $scope.getUserMessage = function () {
            $scope.reset();
            apiService.getUserMessage($scope.user.account, getUserMessageCallback);
        };
        var getUserMessageCallback = {
            onSuccess: function onLoginSuccess(data, status, config, headers) {
                $scope.messages = data;
            },
            onError: function (data, status, hedaers, config) {
            },
            onFinally: function () {
                $scope.loading = false;
                $scope.hasGotAllMessages = true;
            }
        };
        // 根据用户id获取分页的用户消息
        $scope.getUserPageMessage = function () {
            //
            if ($scope.hasGotAllMessages) {
                return;
            }
            //
            $scope.loading = true;
            uiService.ionicLoadingShow({ templateTitle: '正在加载...' });
            apiService.getUserPageMessage($scope.user.account, false, $scope.pageCount, $scope.pageSize, $scope.sortedColumn, getUserPageMessageCallback);
        };
        var getUserPageMessageCallback = {
            onSuccess: function onLoginSuccess(data, status, config, headers) {
                if (_.isEmpty(data.data)) {
                    $scope.hasGotAllMessages = true;
                } else {
                    //
                    if (_.isEmpty($scope.messages)) {
                        $scope.messages = [];
                    }
                    //
                    $scope.messages = $scope.messages.concat(data.data);
                    //
                    $scope.pageCount = $scope.pageCount + 1;
                    if ($scope.pageCount == data.totalPages) {
                        $scope.hasGotAllMessages = true;
                    }
                }
            },
            onError: function (data, status, hedaers, config) {
            },
            onFinally: function () {
                $ionicLoading.hide();
                $scope.loading = false;
            }
        };

        //
        $scope.refreshMessages = function () {
            $scope.hasGotAllMessages = false;
            $scope.pageCount = 0;
            $scope.messages = [];
            $scope.getUserPageMessage();
        };




        // ---------------------------------------------------------------------------------------------------
        $scope.reply = {
            status: 'hidden',   // 回复UI的可见性。'visible', 'hidden'
            msg: '',            // 要回复的消息
            message: null,      // 当前回复对应的message
        }
        $scope.showReply = function (message) {
            $scope.reply.message = message;
            $scope.reply.status = 'visible';
            if (!$scope.reply.msg) {
                $scope.reply.msg = '';
            }
        };
        $scope.hideReply = function () {
            $scope.reply.status = 'hidden';
            $scope.reply.msg = '';
        };
        $scope.replyMessage = function () {
            if ($scope.reply.msg.length == 0) {
                ngCordovaService.showToast('消息不能为空');
                return;
            }
            var toReplyMessage = angular.copy($scope.reply.message);
            toReplyMessage.repliedMessage = $scope.reply.msg;
            toReplyMessage.repliedUserId = $scope.user.account;
            apiService.updateUserMessage(toReplyMessage, replyMessageCallback);
        };
        var replyMessageCallback = {
            onSuccess: function onLoginSuccess(data, status, config, headers) {
                console.log('回复成功');
                ngCordovaService.showToast('回复成功');
                // 与后台做过沟通，返回的数据有2个，使用第一个data[0]替换当前被回复的user_message即可
                var user_message = data[0];
                for (var i = 0; i < $scope.messages.length; i++) {
                    if ($scope.messages[i].id == user_message.id) {
                        $scope.messages[i] = user_message;
                        break;
                    }
                }
                // $scope.reply.message.repliedTime = user_message.repliedTime;
                // $scope.reply.message.repliedMessage = user_message.repliedMessage;
                // TODO toast
                $scope.hideReply();
            },
            onError: function (data, status, hedaers, config) {
                console.warn('回复失败');
                ngCordovaService.showToast('回复失败');
            },
            onFinally: function () {
            }
        };




        // ---------------------------------------------------------------------------------------------------
        $scope.refreshMessages();

    });
