angular
  .module("starter.controllers")

  .controller(
    "MineCtrl",
    function (
      $rootScope,
      $scope,
      $stateParams,
      $state,
      $ionicHistory,
      $ionicLoading,
      apiService,
      uiService,
      ngCordovaService,
      $ionicTabsDelegate,
      cordovaService,
      $cordovaBarcodeScanner,
      $cordovaFileTransfer,
      $cordovaCamera,
      $http,
      apiConstants
    ) {
      $ionicHistory.clearHistory();

      //自主办证
      $scope.goCardNote = function () {
        $ionicHistory.clearCache().then(function () {
          $state.go("tab.cardNote");
        });
      };
      //
      $scope.loggedIn = $rootScope.user != null;
      if (!$scope.loggedIn) {
        $scope.user = {
          account: window.localStorage.getItem("loginInfo_account"),
        };
      }
      $scope.login = function () {
        //
        uiService.ionicLoadingShow({ templateTitle: "登录..." });
        $http
          .post(
            apiConstants.bookInteraction.user.login +
              "?account=" +
              $scope.user.account +
              "&password=" +
              $scope.user.password
          )
          .success(function (res, status, headers, config) {
            window.localStorage.setItem(
              "access_token",
              headers("access-token")
            );
            window.localStorage.setItem(
              "refresh_token",
              headers("refresh-token")
            );
            if (localStorage.getItem("access_token")) {
              var data = res.data;
              //

              $ionicLoading.hide();
              var msg = "登录成功";
              $rootScope.numberShow = true;
              $rootScope.returnNumberShow = true;
              ngCordovaService.showToast(msg);
              $rootScope.refreshTokenTimer = setInterval(function () {
                if (localStorage.getItem("refresh_token")) {
                  $http({
                    method: "post",
                    url: apiConstants.bookInteraction.user.refresh,
                    headers: {
                      Authorization: localStorage.getItem("refresh_token"),
                    },
                  })
                    .success(function (res, status, headers, config) {
                      window.localStorage.setItem(
                        "access_token",
                        headers("access-token")
                      );
                      window.localStorage.setItem(
                        "refresh_token",
                        headers("refresh-token")
                      );
                    })
                    .error(function (msg) {
                      if ($rootScope.refreshTokenTimer) {
                        clearInterval($rootScope.refreshTokenTimer);
                      }
                      $rootScope.user = null;
                      localStorage.removeItem("loginInfo_password");
                      localStorage.removeItem("reader_info");
                      localStorage.removeItem("access_token");
                      localStorage.removeItem("refresh_token");
                      // 清除用户信息
                      $rootScope.userInfo = null;
                      $state.go("tab.mine");
                    });
                }
              }, 60000);
              //
              $scope.loggedIn = true;
              // TODO 临时记录原先的密码
              data.password = $scope.user.password;
              // 防止修改头像之后，重新登录，图像依然是原先的。
              if (data.photo_url) {
                data.photo_url = data.photo_url + "?t=" + new Date().getTime();
              }
              // 保存ALEPH的用户数据
              $scope.user = data;
              localStorage.setItem("reader_info", JSON.stringify(data));
              $rootScope.user = $scope.user;
              // store login info
              localStorage.setItem("loginInfo_account", data.account);
              localStorage.setItem("loginInfo_password", data.password);
              // check the previous state
              var fromState = $stateParams.fromState;
              var currentStateName = $ionicHistory.currentStateName();
              if (fromState && fromState != currentStateName) {
                $ionicHistory.goBack();
              }
              // 获取用户信息
              apiService.getUserInfo($rootScope.user.account, {
                onSuccess: function (data, status, config, headers) {
                  // 保存用户信息
                  $rootScope.userInfo = data;
                },
              });
              //用户最大可借本数
              apiService.borrowCount($rootScope.user.account, {
                onSuccess: function (data, status, config, headers) {
                  $rootScope.allowBorrowCount = data;
                },
              });
              function loadImage(url, callback) {
                var img = new Image();
                img.src = url;
                img.onload = function () {
                  //图片下载完毕时异步调用callback函数。
                  callback.call(img); // 将callback函数this指针切换为img。
                };
              }
              $scope.info = {};
              $scope.account = $rootScope.user.account;
              $scope.uuid = cordovaService.getDeviceInfo().UUID;
              $scope.platform = cordovaService.getDeviceInfo().platform;
              $scope.systemVersion = cordovaService.getDeviceInfo().version;
              $scope.deviceType = cordovaService.getDeviceInfo().model;
              $scope.tags = [$rootScope.user.gender, $rootScope.user.cardType];
              $scope.toJsonTags = angular.toJson($scope.tags);
              //极光推送
              window.plugins.jPushPlugin.init();
              window.plugins.jPushPlugin.setDebugMode(true);
              window.plugins.jPushPlugin.setApplicationIconBadgeNumber(0); //控制角标
              $rootScope.sequence = $rootScope.user.account;
              var tagParams = {
                sequence: $rootScope.sequence,
                tags: [$rootScope.user.gender, $rootScope.user.cardType],
              };
              window.plugins.jPushPlugin.setTags(
                tagParams,
                function (id) {
                  console.log(id);
                },
                function (id) {
                  console.log(id);
                }
              );

              if (ionic.Platform.isIPad() || ionic.Platform.isIOS()) {
                var uuid2 = $scope.uuid.replace(/-/g, "").slice(-20);
                console.log(uuid2);
              } else {
                var uuid2 = $scope.uuid;
              }
              var params = {
                sequence: $rootScope.sequence,
                alias: $rootScope.user.account + "_" + uuid2,
              };
              window.plugins.jPushPlugin.setAlias(
                params,
                function (data) {
                  console.log(data);
                },
                function (data) {
                  console.log(data);
                }
              );
              window.plugins.jPushPlugin.getRegistrationID(function (id) {
                try {
                  console.log("JPushPlugin:registrationID is " + id);
                  $scope.registrationId = id;
                  if (id.length == 0) {
                    var t1 = window.setTimeout(getRegistrationID, 1000);
                  }
                } catch (exception) {
                  console.log(exception);
                }
              });
              ngCordovaService.getAppVersionNumber({
                onSuccess: function (data, status, config, headers) {
                  $scope.appVersion = data;
                  $scope.info = {
                    account: $scope.account,
                    uuid: $scope.uuid,
                    imei: "",
                    deviceType: $scope.deviceType,
                    platform: $scope.platform,
                    registrationId: $scope.registrationId,
                    systemVersion: $scope.systemVersion,
                    appVersion: $scope.appVersion,
                    tags: $scope.toJsonTags,
                  };
                  //上传设备信息
                  apiService.deviceInfo($scope.info, {
                    onSuccess: function (data, status, config, headers) {
                      console.log(data);
                    },
                    onError: function (data, status, config, headers) {
                      console.log(data);
                    },
                  });
                },
                onError: function (data, status, config, headers) {},
              });
              //接收消息并跳转相应的页面
              if (ionic.Platform.isIPad() || ionic.Platform.isIOS()) {
                document.addEventListener(
                  "jpush.openNotification",
                  function (data) {
                    var currentViewName = $ionicHistory.currentView().stateName;
                    var obj = angular.fromJson(data);
                    var msg = obj.aps.alert;
                    console.log(msg);
                    var type = "LOANBOOK";
                    if (
                      currentViewName == "tab.bookhome" ||
                      currentViewName == "tab.bookhomesetting" ||
                      currentViewName == "tab.bhbookdetail" ||
                      currentViewName == "tab.bhHomeBooks" ||
                      currentViewName == "tab.bookhomeorder_return_detai" ||
                      currentViewName == "tab.bookhomeorderreturn" ||
                      currentViewName == "tab.bookhomemyorder" ||
                      currentViewName == "tab.bookhomemessage" ||
                      currentViewName == "tab.bookhomeorder_detail" ||
                      currentViewName == "tab.bookhomepayconfirm"
                    ) {
                      $state.go("tab.bookhomemessage", {
                        msg: msg,
                        type: type,
                      });
                    } else if (
                      currentViewName == "tab.discovery" ||
                      currentViewName == "tab.dcbhdetail" ||
                      currentViewName == "tab.dcbookdetaildrift" ||
                      currentViewName == "tab.dcHomeBooks" ||
                      currentViewName == "tab.dcHomeBookLeaveMessage" ||
                      currentViewName == "tab.bhorderconfirm" ||
                      currentViewName == "tab.discoveryorder_return_detai" ||
                      currentViewName == "tab.discoveryorderreturn" ||
                      currentViewName == "tab.discoverymyorder" ||
                      currentViewName == "tab.discoverymessage" ||
                      currentViewName == "tab.discoveryorder_detail" ||
                      currentViewName == "tab.discoverypayconfirm"
                    ) {
                      $state.go("tab.discoverymessage", {
                        msg: msg,
                        type: type,
                      });
                    } else if (
                      currentViewName == "tab.home" ||
                      currentViewName == "tab.newbook-more " ||
                      currentViewName == "tab.homeminereserve" ||
                      currentViewName == "tab.homeorderconfirm" ||
                      currentViewName == "tab.goodbook-more" ||
                      currentViewName == "tab.searchBook" ||
                      currentViewName == "tab.conditinalSearchBook" ||
                      currentViewName == "tab.book-detail" ||
                      currentViewName == "tab.top-loaned-books" ||
                      currentViewName == "tab.category" ||
                      currentViewName == "tab.myborrowed" ||
                      currentViewName == "tab.homeorderreturn" ||
                      currentViewName == "tab.historyLoanedBookDetail" ||
                      currentViewName == "tab.homeorder_return_detail" ||
                      currentViewName == "tab.activityworldmine" ||
                      currentViewName == "tab.activitydetail" ||
                      currentViewName == "tab.activityCreate" ||
                      currentViewName == "tab.activityPatch" ||
                      currentViewName == "tab.payconfirm" ||
                      currentViewName == "returnbook" ||
                      currentViewName == "tab.homemyorder" ||
                      currentViewName == "tab.message" ||
                      currentViewName == "tab.homeorder_detail" ||
                      currentViewName == "tab.payconfirm" ||
                      currentViewName == "tab.homemine_check_messages" ||
                      currentViewName == "tab.homescanResult"
                    ) {
                      $state.go("tab.message", { msg: msg, type: type });
                    } else {
                      $state.go("tab.minemessage", { msg: msg, type: type });
                    }
                  },
                  false
                );
              } else {
                window.plugins.jPushPlugin.openNotificationInAndroidCallback = function (
                  data
                ) {
                  var currentViewName = $ionicHistory.currentView().stateName;
                  var obj = angular.fromJson(data);
                  var msg = obj.extras["cn.jpush.android.ALERT"];
                  var type = obj.extras.messageType;
                  if (
                    currentViewName == "tab.bookhome" ||
                    currentViewName == "tab.bookhomesetting" ||
                    currentViewName == "tab.bhbookdetail" ||
                    currentViewName == "tab.bhHomeBooks" ||
                    currentViewName == "tab.bookhomeorder_return_detai" ||
                    currentViewName == "tab.bookhomeorderreturn" ||
                    currentViewName == "tab.bookhomemyorder" ||
                    currentViewName == "tab.bookhomemessage" ||
                    currentViewName == "tab.bookhomeorder_detail" ||
                    currentViewName == "tab.bookhomepayconfirm"
                  ) {
                    $state.go("tab.bookhomemessage", { msg: msg, type: type });
                  } else if (
                    currentViewName == "tab.discovery" ||
                    currentViewName == "tab.dcbhdetail" ||
                    currentViewName == "tab.dcbookdetaildrift" ||
                    currentViewName == "tab.dcHomeBooks" ||
                    currentViewName == "tab.dcHomeBookLeaveMessage" ||
                    currentViewName == "tab.bhorderconfirm" ||
                    currentViewName == "tab.discoveryorder_return_detai" ||
                    currentViewName == "tab.discoveryorderreturn" ||
                    currentViewName == "tab.discoverymyorder" ||
                    currentViewName == "tab.discoverymessage" ||
                    currentViewName == "tab.discoveryorder_detail" ||
                    currentViewName == "tab.discoverypayconfirm"
                  ) {
                    $state.go("tab.discoverymessage", { msg: msg, type: type });
                  } else if (
                    currentViewName == "tab.home" ||
                    currentViewName == "tab.newbook-more" ||
                    currentViewName == "tab.homeminereserve" ||
                    currentViewName == "tab.homeorderconfirm" ||
                    currentViewName == "tab.goodbook-more" ||
                    currentViewName == "tab.searchBook" ||
                    currentViewName == "tab.conditinalSearchBook" ||
                    currentViewName == "tab.book-detail" ||
                    currentViewName == "tab.top-loaned-books" ||
                    currentViewName == "tab.category" ||
                    currentViewName == "tab.myborrowed" ||
                    currentViewName == "tab.homeorderreturn" ||
                    currentViewName == "tab.historyLoanedBookDetail" ||
                    currentViewName == "tab.homeorder_return_detail" ||
                    currentViewName == "tab.activityworldmine" ||
                    currentViewName == "tab.activitydetail" ||
                    currentViewName == "tab.activityCreate" ||
                    currentViewName == "tab.activityPatch" ||
                    currentViewName == "tab.payconfirm" ||
                    currentViewName == "returnbook" ||
                    currentViewName == "tab.homemyorder" ||
                    currentViewName == "tab.message" ||
                    currentViewName == "tab.homeorder_detail" ||
                    currentViewName == "tab.payconfirm" ||
                    currentViewName == "tab.homemine_check_messages" ||
                    currentViewName == "tab.homescanResult"
                  ) {
                    $state.go("tab.message", { msg: msg, type: type });
                  } else {
                    $state.go("tab.minemessage", { msg: msg, type: type });
                  }
                };
              }
              //获取用户不同状态的借书订单数量
              apiService.checkAllOrder($rootScope.user.borrowID, {
                onSuccess: function (data, status, config, headers) {
                  if (data) {
                    var amountCount = 0;
                    if (data.packing) {
                      amountCount += parseInt(data.packing);
                    }
                    if (data.paying) {
                      amountCount += parseInt(data.paying);
                    }
                    if (data.delivering) {
                      amountCount += parseInt(data.delivering);
                    }
                    if (data.receiving) {
                      amountCount += parseInt(data.receiving);
                    }
                    if (data.picking) {
                      amountCount += parseInt(data.picking);
                    }
                    $rootScope.myOrderCount = amountCount;
                    if ($rootScope.myOrderCount == 0) {
                      $rootScope.numberShow = false;
                    } else {
                      $rootScope.numberShow = true;
                    }
                  }
                },
              });
              //查看用户还书订单数量
              apiService.checkReturnOrders($rootScope.user.borrowID, {
                onSuccess: function (data, status, config, headers) {
                  if (data) {
                    var amountCount = 0;
                    if (data.returning) {
                      amountCount += parseInt(data.returning);
                    }
                    $rootScope.myReturnOrder = amountCount;
                    if ($rootScope.myReturnOrder == 0) {
                      $rootScope.returnNumberShow = false;
                    } else {
                      $rootScope.returnNumberShow = true;
                    }
                  }
                },
              });
            }
          })
          .error(function (error) {
            $ionicLoading.hide();
            ngCordovaService.showToast("服务器连接失败，请稍后尝试");
          });
      };
      // -----------------------------------------------------------------------------------------
      /*********wsc-change********/
      $scope.goFans = function () {
        $ionicHistory.clearCache().then(function () {
          $state.go("tab.mine_fans");
        });
      };
      $scope.goFollows = function () {
        $ionicHistory.clearCache().then(function () {
          $state.go("tab.mine_follows");
        });
      };
      $scope.goFavorites = function () {
        $ionicHistory.clearCache().then(function () {
          $state.go("tab.mine_favorites");
        });
      };
      /*********************************/
      $scope.goCheckMessages = function () {
        $state.go("tab.mine_check_messages");
      };
      $scope.goYouchooseIpay = function () {
        $ionicHistory.clearCache().then(function () {
          $state.go("tab.mineyouchooseipay");
        });
      };
      $scope.goMyBorrowed = function () {
        $ionicHistory.clearCache().then(function () {
          $state.go("tab.minemyborrowed");
        });
      };
      $scope.goMyReserve = function () {
        $ionicHistory.clearCache().then(function () {
          $state.go("tab.minereserve");
        });
      };
      $scope.goMyOrder = function () {
        $ionicHistory.clearCache().then(function () {
          $state.go("tab.myorder");
        });
      };
      $scope.goReturnOrder = function () {
        $ionicHistory.clearCache().then(function () {
          $state.go("tab.orderreturn");
        });
      };
      $scope.goBookCart = function () {
        $ionicHistory.clearCache().then(function () {
          $state.go("tab.bookCart");
        });
      };
      $scope.getBarcode = function () {
        $cordovaBarcodeScanner.scan().then(
          function (result) {
            if (!$rootScope.user) {
              ngCordovaService.showToast("请登录后进行操作...");
            } else {
              if (result.text) {
                $scope.qrcodeArr = result.text.split("?");
                var scanParams = $scope.qrcodeArr[1];
                if (
                  $scope.qrcodeArr[0] ==
                  "http://wx.leituzhiyue.com/haiheng/qrcode_scaning"
                ) {
                  uiService.ionicLoadingShow({
                    templateTitle: "正在登录，请耐心等待...",
                  });
                  apiService.haihengScanQRcode(
                    $rootScope.user.account,
                    scanParams,
                    {
                      onSuccess: function (data, status, config, headers) {
                        if (data.status == "OK") {
                          $state.go("tab.scanResult", {
                            scanResult: data.data,
                          });
                        } else {
                          ngCordovaService.showToast(data.data);
                        }
                      },
                      onError: function (data, status, config, headers) {
                        ngCordovaService.showToast("登录失败，请稍后重试...");
                        //
                      },
                      onFinally: function () {
                        $ionicLoading.hide();
                      },
                    }
                  );
                } else {
                  uiService.ionicLoadingShow({
                    templateTitle: "正在开门，请耐心等待...",
                  });
                  $scope.qrcode = scanParams.replace(
                    "WechatOpenDoor",
                    "AppOpenDoor"
                  );
                  apiService.scanBarcodeOpen(
                    $rootScope.user.account,
                    $rootScope.user.name,
                    $scope.qrcode,
                    {
                      onSuccess: function (data, status, config, headers) {
                        if (data.status == "OK") {
                          $state.go("tab.scanResult", {
                            scanResult: data.data,
                          });
                        } else {
                          ngCordovaService.showToast(data.data);
                        }
                      },
                      onError: function (data, status, config, headers) {
                        ngCordovaService.showToast("开门失败，请稍后重试...");
                        //
                      },
                      onFinally: function () {
                        $ionicLoading.hide();
                      },
                    }
                  );
                }
              }
            }
          },
          function (error) {
            consolog.warn("Scanning failed: " + error);
            ngCordovaService.showToast("摄像头可能正在使用中，请稍后再试...");
          }
        );
      };
      $scope.capturePictureByCamera = function () {
        var options = {
          destinationType: Camera.DestinationType.FILE_URI,
          sourceType: Camera.PictureSourceType.CAMERA,
          correctOrientation: true, //ios上所拍的图片方向不对
          saveToPhotoAlbum: true,
        };

        $cordovaCamera.getPicture(options).then(
          function (imageURI) {
            console.log("capturePictureByCamera. Image URI: " + imageURI);
            $scope.faceImgUrl = imageURI;
            $scope.uploadNewAvator();
          },
          function (err) {
            // error
            console.log("capturePictureByCamera. Image URI err : " + err);
          }
        );
      };
      $scope.uploadNewAvator = function () {
        uiService.ionicLoadingShow({ templateTitle: "正在上传验证..." });
        var server =
          bookroomBaseUrl +
          "/bookroom_api/reader_face/check_upload_face_and_name/" +
          $scope.user.account +
          "?name=" +
          $scope.user.name +
          "&faceSource=app";
        var filePath = $scope.faceImgUrl;
        var options = null;
        $cordovaFileTransfer.upload(server, filePath, options).then(
          function (result) {
            // Success!
            $ionicLoading.hide();
            ngCordovaService.showToast(angular.fromJson(result.response).data);
          },
          function (err) {
            // Error
            $ionicLoading.hide();
            ngCordovaService.showToast("服务器连接失败，请稍后尝试");
          }
        );
      };
      $ionicTabsDelegate.showBar(true);
    }
  );
