angular
  .module("starter.controllers")

  .controller(
    "VersionCtrl",
    function (
      $rootScope,
      $scope,
      $state,
      $ionicPopup,
      apiService,
      ngCordovaService,
      $ionicHistory,
      appService,
      $ionicTabsDelegate
    ) {
      $scope.goVersionHistory = function () {
        $state.go("tab.mine_function");
      };

      // 获取当前版本信息
      $scope.getAppInfo = function () {
        return appService.getCheckedAppInfo();
      };
      // 获取当前最新版本信息
      $scope.getNewestAppVersion = function () {
        appService.getNewestAppVersion();
      };
      // 检查（服务器）最新版本信息，并显示最新版本信息对话框。
      $scope.checkNewestVersion = function () {
        appService.retrieveNewestAppVersion(true, false);
      };
      // 有新版本
      $scope.hasNewestVersion = function () {
        var checkedAppInfo = appService.getCheckedAppInfo();
        var newestAppVersion = appService.getNewestAppVersion();
        if (checkedAppInfo && newestAppVersion) {
          if (checkedAppInfo.versionCode && newestAppVersion.versionCode) {
            if (checkedAppInfo.versionCode < newestAppVersion.versionCode) {
              if (newestAppVersion.forceUpdate == true) {
                return true;
              }
            }
          }
        }
        return false;
      };

      // ------------------------------------------------------------------------------------------------------------
      // 检查最新版本
      $scope.isAndroid = ionic.Platform.isAndroid();
      if (ionic.Platform.isAndroid()) {
        // IOS 不允许有升级按钮或者提示
        if (!appService.getCheckedAppInfo().versionCode) {
          appService.checkAppInfo();
        }
        if (!appService.getNewestAppVersion().versionCode) {
          appService.retrieveNewestAppVersion(false);
        }
      }

      $ionicTabsDelegate.showBar(false);
    }
  );
