angular.module('starter.controllers')

    .controller('UnboundFaceCtrl', function ($scope, $ionicTabsDelegate, $rootScope, $ionicHistory, apiService, uiService, $ionicLoading, ngCordovaService) {
        $ionicTabsDelegate.showBar(false);
        $scope.ifUpload = false;
        getFaceBindStatus();
        function getFaceBindStatus(){
            uiService.ionicLoadingShow({ templateTitle: '获取数据...' });
            apiService.gedFaceBindStatus($rootScope.user.account, {
                onSuccess: function (data, status, config, headers) {
                    if (data.status == "OK") {
                        getUserFacePic();
                    } else {
                        ngCordovaService.showToast(data.data);
                        $scope.ifUpload = true;
                    }
                },
                onError: function (data, status, config, headers) {
                    ngCordovaService.showToast("服务器连接失败，请稍后尝试");
                },
                onFinally: function () {
                    $ionicLoading.hide();
                }
            })
        }
        
        function getUserFacePic() {
            uiService.ionicLoadingShow({ templateTitle: '获取人脸照片...' });
            apiService.queryFacePic($rootScope.user.account, {
                onSuccess: function (data, status, config, headers) {
                    if (data.status == "OK") {
                        $scope.imgSrc = data.data;
                    } else {
                        ngCordovaService.showToast(data.data);
                    }
                },
                onError: function (data, status, config, headers) {
                    ngCordovaService.showToast("服务器连接失败，请稍后尝试");
                },
                onFinally: function () {
                    $ionicLoading.hide();
                }
            })
        }

        $scope.unboundFace = function () {
            uiService.ionicLoadingShow({ templateTitle: '正在解除绑定...' });
            apiService.unboundUserFace($rootScope.user.account, {
                onSuccess: function (data, status, config, headers) {
                    if (data.status == "OK") {
                        ngCordovaService.showToast(data.data);
                        $ionicHistory.goBack();
                    } else {
                        ngCordovaService.showToast(data.data);
                        $scope.ifUpload = true;
                    }
                },
                onError: function (data, status, config, headers) {
                    ngCordovaService.showToast("服务器连接失败，请稍后尝试");
                },
                onFinally: function () {
                    $ionicLoading.hide();
                }
            });
        }
    })