angular.module('starter.controllers')

    .controller('PayConfirmCtrl', function ($scope, $stateParams, $state, $ionicPopup, $timeout, $ionicHistory, apiService, uiService, $ionicLoading, ngCordovaService, $ionicTabsDelegate, broadcastService, broadcastConstants, appLogService) {

        $scope.payTypes = [
            {
                value: "alipay",
                text: "支付宝支付",
                icon: 'img/alipay/mobile/36x36.png',
                pay_success_img: 'img/alipay/round/biao.png',
                pay_failed_img: 'img/alipay/round/biao.png',
                enable: true,
                pay: function () { $scope.getAliPayInfo(true); },
            },
            {
                value: "wxpay",
                text: "微信支付",
                icon: 'img/weixin/Icon/icon32_appwx_logo.png',
                pay_success_img: 'img/weixin/Icon/icon64_appwx_logo.png',
                pay_failed_img: 'img/weixin/Icon/icon64_appwx_logo.png',
                enable: undefined,
                pay: function () { $scope.getWxPayInfo(true); },
                // pay: function () { $scope.payWithWxPayInDebug(); },
            },
            // { text: "到付", value: "到付" },
        ];
        $scope.data = {
            payTypeIndex: undefined,
        };

        //判断是押金支付还是借书支付
        $scope.judgePay = false;
        //

        if ($stateParams.cardInfo) {
            $scope.judgePay = true;
            $scope.cardInfo = $stateParams.cardInfo;
        } else {
            $scope.judgePay = false;
            $scope.order = $stateParams.order;
            $scope.orderId = $stateParams.order.order.orderId;
        }

        //
        $scope.state = 'pay'; // 'pay', 'pay_result_success', 'pay_result_failed'
        $scope.getTitle = function () {
            var title = '支付';
            if ($scope.state == 'pay') {
                title = '支付';
            } else if ($scope.state == 'pay_result_success') {
                title = '支付结果';
            } else if ($scope.state == 'pay_result_failed') {
                title = '支付结果';
            }
            return title;
        };

        $scope.getPayInfoAndPay = function () {
            if ($scope.judgePay) {
                if (!$scope.cardInfo.cash) {
                    ngCordovaService.showToast('应付金额有错误');
                    return;
                }
            } else {
                if (!$scope.order.order.totalAmount) {
                    ngCordovaService.showToast('应付金额有错误');
                    return;
                }
            }

            if ($scope.data.payTypeIndex == undefined || $scope.data.payTypeIndex == null) {
                ngCordovaService.showToast('请先选择支付方式');
                return;
            }
            if ($scope.data.payTypeIndex < 0 ||
                $scope.data.payTypeIndex >= $scope.payTypes.length) {
                console.warn('代码逻辑错误。支付方式不在集合范围中。');
                return;
            }
            console.log('当前选择的支付方式是：' + $scope.payTypes[$scope.data.payTypeIndex].value);
            var paytype = $scope.payTypes[$scope.data.payTypeIndex];
            if (paytype.enable == true) {
                paytype.pay();
            } else {
                ngCordovaService.showToast('无法使用' + paytype.text + '。请检查是否应该安装了相关软件。');
            }
        };


        // ----------------------------------------------------------------------------------------------
        $scope.checkWechat = function () {
            if (Wechat) {
                Wechat.isInstalled(function (installed) {
                    console.log('在设备中检测到微信 = ' + (installed ? "Yes" : "No"));
                    for (var i = 0; i < $scope.payTypes.length; i++) {
                        var payType = $scope.payTypes[i];
                        if (payType) {
                            if (payType.value == 'wxpay') {
                                payType.enable = installed ? true : false;
                                break;
                            }
                        }
                    }
                }, function (reason) {
                    console.warn('在设备中检测微信出现异常。reason = ' + reason);
                });
            }
        };
        $scope.getAliPayInfo = function (toPay) {
            uiService.ionicLoadingShow({ templateTitle: '正在获取支付信息...' });
            if ($scope.judgePay == false) {
                apiService.getAliPayInfo($scope.orderId,
                    {
                        onSuccess: function (data, status, config, headers) {
                            var alipay = data.data;
                            if (toPay == true) {
                                $scope.payWithAlipay(alipay);
                            }
                        },
                        onError: function (data, status, config, headers) {
                            ngCordovaService.showToast('获取支付信息失败，请稍后重试...');
                            //
                            var server_data = data;
                            var module = 'getAliPayInfo';
                            var desciption = '获取支付宝支付信息失败';
                            $scope.submitErrorLog(server_data, module, desciption);
                        },
                        onFinally: function () {
                            $ionicLoading.hide();
                        }
                    }
                );
            } else {
                apiService.cashAlipay($scope.cardInfo.cardNum, {
                    //$scope.cardInfo.cardNum
                    onSuccess: function (data, status, config, headers) {
                        var alipay = data.data;
                        if (data.status == 'OK') {
                            if (toPay == true) {
                                $scope.payWithAlipay(alipay);
                            }
                        } else {
                            ngCordovaService.showToast(alipay);
                            return;
                        }

                    },
                    onError: function (data, status, config, headers) {
                        ngCordovaService.showToast('获取支付信息失败，请稍后重试...');
                        //
                        var server_data = data;
                        var module = 'getAliPayInfo';
                        var desciption = '获取支付宝支付信息失败';
                        $scope.submitErrorLog(server_data, module, desciption);
                    },
                    onFinally: function () {
                        $ionicLoading.hide();
                    }
                });
            }

        };
        $scope.payWithAlipay = function (alipay) {
            // 第一步：订单在服务端签名生成订单信息，具体请参考官网进行签名处理
            var payInfo = alipay.payContent;
            // 第二步：调用支付插件            
            cordova.plugins.alipay.payment(payInfo,
                // success
                function (e) {
                    console.log('alipay. success.');
                    $scope.state = 'pay_result_success';
                    $scope.$apply();
                    if ($scope.judgePay == false) {
                        /*************wsc-change***************/
                        //发送广播
                        broadcastService.send(
                            broadcastConstants.names.onPayConfirmBookChanged,
                            {
                                operation: 'pay',
                                result: 'success',
                            }
                        );
                    }
                },
                // error
                function (e) {
                    console.error('alipay. error. \n' + angular.toJson(e));
                    var error_info = null;
                    if (e && e.resultStatus) {
                        switch (e.resultStatus) {
                            case '4000':
                                var reason = '订单支付失败';
                                error_info = e.resultStatus + ':' + reason;
                                ngCordovaService.showToast(reason);
                                $scope.state = 'pay_result_failed';
                                $scope.$apply();
                                break;
                            case '6001':
                                var reason = '您取消了支付操作';
                                error_info = e.resultStatus + ':' + reason;
                                ngCordovaService.showToast(reason);
                                break;
                            case '6002':
                                var reason = '网络连接出错';
                                error_info = e.resultStatus + ':' + reason;
                                ngCordovaService.showToast(reason);
                                $scope.state = 'pay_result_failed';
                                $scope.$apply();
                                break;
                            default:
                                var reason = '订单支付失败，原因未知。';
                                error_info = e.resultStatus + ':' + reason;
                                ngCordovaService.showToast(reason);
                                $scope.state = 'pay_result_failed';
                                $scope.$apply();
                                break;
                        }
                    } else {
                        var reason = '订单支付失败，原因未知。';
                        error_info = e.resultStatus + ':' + reason;
                        ngCordovaService.showToast(reason);
                        $scope.state = 'pay_result_failed';
                        $scope.$apply();
                    }
                    //
                    var server_data = e;
                    var module = 'alipay.payment';
                    var desciption = error_info;
                    $scope.submitErrorLog(server_data, module, desciption);
                }
            );

            //e.resultStatus  状态代码  e.result  本次操作返回的结果数据 e.memo 提示信息
            //e.resultStatus  9000  订单支付成功 ;8000 正在处理中  调用function success
            //e.resultStatus  4000  订单支付失败 ;6001  用户中途取消 ;6002 网络连接出错  调用function error
            //当e.resultStatus为9000时，请去服务端验证支付结果
            /**
             * 同步返回的结果必须放置到服务端进行验证（验证的规则请看https://doc.open.alipay.com/doc2/
             * detail.htm?spm=0.0.0.0.xdvAU6&treeId=59&articleId=103665&
             * docType=1) 建议商户依赖异步通知
             */
        };
        // ----------------------------------------------------------------------------------------------
        $scope.getWxPayInfo = function (toPay) {
            uiService.ionicLoadingShow({ templateTitle: '正在获取支付信息...' });
            if ($scope.judgePay == false) {
                apiService.getWxPayInfo($scope.orderId,
                    {
                        onSuccess: function (data, status, config, headers) {
                            if (data) {
                                switch (data.status) {
                                    case 'OK':
                                        try {
                                            var params = angular.fromJson(data.data);
                                            if (toPay == true) {
                                                $scope.payWithWxPay(params); // 正规格式
                                            }
                                        } catch (error) {
                                            //
                                            var txt = '获取的微信支付信息格式不正确';
                                            ngCordovaService.showToast('支付数据格式不合法，请稍后重试...');
                                            //
                                            var server_data = data;
                                            var module = 'getWxPayInfo';
                                            var desciption = '获取的微信支付信息格式不正确';
                                            $scope.submitErrorLog(server_data, module, desciption);
                                        }
                                        break;
                                    case 'ERROR':
                                        ngCordovaService.showToast(data.data);
                                        console.log('获取支付信息失败。' + angular.toJson(data));
                                        //
                                        var server_data = data;
                                        var module = 'getWxPayInfo';
                                        var desciption = '获取支付信息失败';
                                        $scope.submitErrorLog(server_data, module, desciption);
                                        break;
                                    default:
                                        break;
                                }
                            }
                        },
                        onError: function (data, status, config, headers) {
                            ngCordovaService.showToast('获取支付信息失败，请稍后重试...');
                            //
                            var server_data = data;
                            var module = 'getWxPayInfo';
                            var desciption = '获取支付信息失败';
                            $scope.submitErrorLog(server_data, module, desciption);
                        },
                        onFinally: function () {
                            $ionicLoading.hide();
                        }
                    }
                );
            } else {
                apiService.cashWxpay($scope.cardInfo.cardNum,
                    {
                        onSuccess: function (data, status, config, headers) {
                            if (data) {
                                switch (data.status) {
                                    case 'OK':
                                        try {
                                            var params = angular.fromJson(data.data);
                                            if (toPay == true) {
                                                $scope.payWithWxPay(params); // 正规格式
                                            }
                                        } catch (error) {
                                            //
                                            var txt = '获取的微信支付信息格式不正确';
                                            ngCordovaService.showToast('支付数据格式不合法，请稍后重试...');
                                            //
                                            var server_data = data;
                                            var module = 'getWxPayInfo';
                                            var desciption = '获取的微信支付信息格式不正确';
                                            $scope.submitErrorLog(server_data, module, desciption);
                                        }
                                        break;
                                    case 'ERROR':
                                        ngCordovaService.showToast(data.data);
                                        console.log('获取支付信息失败。' + angular.toJson(data));
                                        //
                                        var server_data = data;
                                        var module = 'getWxPayInfo';
                                        var desciption = '获取支付信息失败';
                                        $scope.submitErrorLog(server_data, module, desciption);
                                        break;
                                    default:
                                        break;
                                }
                            }
                        },
                        onError: function (data, status, config, headers) {
                            ngCordovaService.showToast('获取支付信息失败，请稍后重试...');
                            //
                            var server_data = data;
                            var module = 'getWxPayInfo';
                            var desciption = '获取支付信息失败';
                            $scope.submitErrorLog(server_data, module, desciption);
                        },
                        onFinally: function () {
                            $ionicLoading.hide();
                        }
                    }
                );
            }
        };
        $scope.payWithWxPay = function (params) {
            if (params) {
                var result = checkWxPayParams(params);
                if (result.result == 'OK') {
                    if (Wechat) {
                        Wechat.sendPaymentRequest(params, function () {
                            // ngCordovaService.showToast('支付成功');
                            // 调用完cordova之后，立即调用toast会不显示
                            $timeout(function () {
                                ngCordovaService.showToast('支付成功');
                            }, 1000);
                            console.log('alipay. success.');
                            $scope.state = 'pay_result_success';
                            $scope.$apply();

                            if ($scope.judgePay == false) {
                                /*************wsc-change***************/
                                //发送广播
                                broadcastService.send(
                                    broadcastConstants.names.onPayConfirmBookChanged,
                                    {
                                        operation: 'pay',
                                        result: 'success',
                                    }
                                );
                            }

                        }, function (reason) {
                            //
                            console.warn('微信支付失败。 reason is ' + reason);
                            // ngCordovaService.showToast('支付失败');
                            // 调用完cordova之后，立即调用toast会不显示
                            $timeout(function () {
                                ngCordovaService.showToast('支付失败');
                            }, 1000);
                            //
                            var detail = reason;
                            var module = 'payWithWxPay';
                            var desciption = '使用微信支付订单失败。订单号是：' + $scope.orderId;
                            $scope.submitErrorLog(detail, module, desciption);
                        });
                    } else {
                        ngCordovaService.showToast('微信支付插件正在准备中，请稍后重试...');
                    }
                } else {
                    console.warn('微信支付信息异常。异常信息是:' + result.msg);
                    ngCordovaService.showToast(result.msg);
                    //
                    var server_data = result;
                    var module = 'WxPay.getWxPayInfo';
                    var desciption = '检查微信支付信息异常';
                    $scope.submitErrorLog(server_data, module, desciption);
                    //
                    return;
                }
            }
        };
        function checkWxPayParams(params) {
            var result = {
                result: undefined, // 'OK', 'ERROR'
                msg: undefined,
                params: params,
            };
            if (params) {
                // 初始化
                result.result = 'OK';
                result.msg = '支付参数正确';
                // 参数查错
                if (!params.appid) {
                    result.result = 'ERROR';
                    result.msg = '支付参数（appid）不存在';
                } else if (!params.noncestr) {
                    result.result = 'ERROR';
                    result.msg = '支付参数（noncestr）不存在';
                } else if (!params.package) {
                    result.result = 'ERROR';
                    result.msg = '支付参数（package）不存在';
                } else if (!params.partnerid) {
                    result.result = 'ERROR';
                    result.msg = '支付参数（partnerid）不存在';
                } else if (!params.prepayid) {
                    result.result = 'ERROR';
                    result.msg = '支付参数（prepayid）不存在';
                } else if (!params.sign) {
                    result.result = 'ERROR';
                    result.msg = '支付参数（sign）不存在';
                } else if (!params.timestamp) {
                    result.result = 'ERROR';
                    result.msg = '支付参数（timestamp）不存在';
                }
            } else {
                result.result = 'ERROR';
                result.msg = '支付参数不存在';
            }
            return result;
        }
        // $scope.payWithWxPay2 = function (params) {
        //     if (params) {
        //         if (!params.appid) {
        //             // 解析临时api返回的数据
        //             params = params.substring(params.indexOf('{') + 1, params.lastIndexOf('}'));
        //             var tmp = params.split(',');
        //             var json = '';
        //             json += "{";
        //             for (var i = 0; i < tmp.length; i++) {
        //                 var t = tmp[i];
        //                 t = t.trim();
        //                 var index = t.indexOf('=');
        //                 if (index >= 0) {
        //                     var left = t.substring(0, index).trim();
        //                     var right = t.substring(index + 1, t.length).trim();
        //                     if (left && right && left != 'null' && right != 'null') {
        //                         json += '"' + left + '"';
        //                         json += ':';
        //                         json += '"' + right + '"';
        //                         if (i < tmp.length - 1) {
        //                             json += ',';
        //                         }
        //                     }
        //                 }
        //             }
        //             json += "}";
        //             params = angular.fromJson(json);
        //         }
        //         $scope.payWithWxPay(params);
        //     }
        // };
        // ACTION：----------请不要删除此下面的代码，这个代码格式是经过测试通过的。----------
        $scope.payWithWxPayInDebug = function () {
            var params = {
                appid: 'wx8c6e9e5eb340754d',
                noncestr: 'r6js16D0HxV28b2v',
                package: 'Sign=WXPay',
                partnerid: '1374031602',
                prepayid: 'wx201711261238104a2d97e2f10194194684',
                sign: 'B43FB288F34FB1D06183FB4D0906A091',
                timestamp: '1511671090',
            };
            $scope.payWithWxPay(params);
        };
        // ACTION：----------请不要删除此上面的代码，这个代码格式是经过测试通过的。----------
        // ----------------------------------------------------------------------------------------------
        $scope.payLater = function () {
            // 发送广播
            // TODO 实际上此处没必要通知-->刷新订单列表
            broadcastService.send(
                broadcastConstants.names.onPayConfirmBookChanged,
                {
                    operation: 'pay',
                    result: 'cancelled',
                }
            );
            //
            $ionicHistory.goBack();
        };


        // -------------------------------------------------------------
        $scope.goSuccessBack = function () {
            if ($scope.judgePay) {
                $ionicHistory.nextViewOptions({
                    disableBack: true
                });
                $state.go('tab.mine');
            } else {
                $ionicHistory.goBack();
            }
        };
        $scope.goBack = function () {
            $ionicHistory.goBack();
        };
        $scope.repayWithAlipay = function () {
            $scope.payWithAlipay();
        };
        $scope.goPayState = function () {
            $scope.state = 'pay';
            $scope.$apply();
        };


        // -------------------------------------------------------------
        $scope.submitErrorLog = function (detail, module, desciption) {
            var log = appLogService.getBaseLog();
            log.level = 'warn';
            log.category = 'module';
            log.module = module;
            log.error = {
                desciption: desciption,
                detail: angular.toJson(detail),
            };
            appLogService.uploadLog(log, {
                onSuccess: function (data, status, config, headers) {
                    console.log('提交异常日志-->成功');
                },
                onError: function (data, status, config, headers) {
                    console.error('提交异常日志-->失败');
                },
                onFinally: function () {
                    //
                }
            });
        };


        // -------------------------------------------------------------

        $ionicTabsDelegate.showBar(false);
        $scope.checkWechat();
    });